!DIR$ FIXEDFORMLINESIZE:132
      subroutine am_plws_vol_cyl(fail)
      use math_blocks
      use rte_blocks
      use header_types
      implicit none

      logical*4, intent(out) :: fail

      N1 = Nscth
      L1 = Lz

      if(compute_u) then
         nmem = nmem + int8(L1)*int8(nword)
      end if

      if(compute_J) then
         nmem = nmem + int8(L1)*int8(nword)
      end if

      if(compute_I) then
         nmem = nmem + int8(N1)*int8(L1)*int8(nword)
      end if
 
      if(nmem .gt. nmem_tot) then
         write(*,*) '** AM_PLWS_VOL_CYL: Not enough free memory to proceed ***********'
         write(*,*) '** [Required Memory] : ', sngl(nmem*nano)    , ' Gb *************'
         write(*,*) '**  [Allowed Memory] : ', sngl(nmem_tot*nano), ' Gb *************'
         write(*,*) '** NOTE: [Allowed Memory] =/= [Available Memory] ****************'
         write(*,*) '** RECOMENDATION: Check parameters nmem_tot, Nscth, Lz'
         fail = .true.
         return
      else
         fail = .false.
      end if

      if(compute_u) then
         allocate(u1D(1:L1))
         u1D = dzero
      end if
         
      if(compute_J) then
         allocate(J1D(1:L1))
         J1D = dzero
      end if
 
      if(compute_I) then
         allocate(I2D(1:N1,1:L1))
         I2D = dzero
      end if

      return
      end
