!DIR$ FIXEDFORMLINESIZE:132
      subroutine report_pars(call_unit)
      use  rte_blocks
      use math_blocks
      implicit none
      character*4, intent(in) :: call_unit

      real*8 kd

 401  format(a30, a10)
 402  format(a30, L3)
 403  format(a30, f8.2, a5)
 404  format(a30, ssen13.2e2)

 405  format(a30, f10.4, a9)
 406  format(a30, f10.4, a17)
 407  format(a30, f10.4, a7)

 411  format(a30, 4i10)
 412  format(a30, 3i10)
 413  format(a30, 2i10)
 414  format(a30, 1i10)

 420  format(a30, 3f10.3,       a3, a8, a1)
 421  format(a30, 2f10.3, 10X, a3, a8, a1)
 422  format(a30, 1f10.3, 20X  a3, a8, a1)

      kd = dsqrt(3.0d0 * mu_a * mu_star)

      write(*,  *) '======================================================================='

      if(call_unit .eq. '*mc*') then
      write(*,403) '              Allowed memory :', nano*nmem_tot, ' [Gb]'
      end if
 
      write(*,  *) '************ Problem description **************************************'
      write(*,401) '                  SourceType :', SourceType
      write(*,401) '               PhaseFunction :', PhaseFunction
      write(*,401) '                      Domain :', Domain
      write(*,401) '                       Units :', Units
      write(*,402) '                Use_Symmetry :', Use_Symmetry
      write(*,402) '           Collimated_Source :', Collimated_Source
      write(*,402) '           Plane_Wave_Source :', Plane_Wave_Source

      write(*,  *) '************ MC parameters ********************************************'
      write(*,404) '      Number of photons [NW] :', float(nw)
      write(*,414) '          Vector length [NR] :', nr
      write(*,411) '                Random seeds :', seed1, seed2, seed3, seed4
      IF(.not. Collimated_Source) THEN
      write(*,413) '     Additional random seeds :', seed5, seed6
      END IF

      write(*,*)   '************** Medium parameters [units of dGt (Dog_Tails)] ***********'

      write(*,405) '  Absorpt coefficient [mu_a] :', mu_a      ,    '  [1/dGt]'
      write(*,405) '    Scatt coefficient [mu_s] :', mu_s      ,    '  [1/dGt]'
      write(*,406) '     Asymmetry parameter [g] :', g         ,    '  [Dimensionless]'
      IF(PhaseFunction .eq. 'EXP') THEN
      write(*,406) '  Exp phase funct par [beta] :', beta      ,    '  [Dimensionless]' 
      END IF
      write(*,405) 'Inv mean free path [mu_star] :', mu_star   ,    '  [1/dGt]'
      write(*,405) '    Diffuse wave number [kd] :', kd        ,    '  [1/dGt]'
      write(*,407) '   Mean free path [ell_star] :', ell_star  ,    '  [dGt]'
      write(*,406) '             [ell_star*mu_t] :', ell_star*mu_t, '  [Dimensionless]'
      write(*,406) '             [ell_star*kd  ] :', ell_star*kd,   '  [Dimensionless]'
      IF(Units .eq. 'Dog_Tail') THEN
      write(*,406) '  Optical Depth [L/ell_star] :', opt_depth,     '  [Dimensionless]'
      END IF

      write(*,*)   '************** Sample and discretization parameters *******************'

      write(*,421) '        Sample [zsmin,zsmax] :', zsmin, zsmax,         '  [', Units, ']'

      IF(Domain .eq. 'VOL') THEN                 ! Domain = 'VOL'

         IF(Use_Symmetry) THEN                   ! Domain = 'VOL'; Use_Symmetry = T

            IF(Plane_Wave_Source) THEN           ! Domain = 'VOL'; Use_Symmetry = T; Plane_Wave_Source = T

      write(*,421) '        Domain [zbmin,zbmax] :', zbmin, zbmax,         '  [', Units, ']'
      write(*,414) '         Discretization [Lz] :', Lz
      write(*,422) '                  Voxel [hz] :', hz,                   '  [', Units, ']'
      
            ELSE                                 ! Domain = 'VOL'; Use_Symmetry = T; Plane_Wave_Source = F

      write(*,420) ' Domain [zbmin,zbmax,rhomax] :', zbmin, zbmax, rhomax, '  [', Units, ']'
      write(*,413) '   Discretization [Lz, Lrho] :', Lz,    Lrho
      write(*,421) '            Voxel [hz, hrho] :', hz,    hrho,          '  [', Units, ']'
      
            END IF                               ! End IF(Pane_Wave_Source)

         ELSE                                    ! Domain = 'VOL'; Use_Symmetry = F

            IF(Plane_Wave_Source) THEN           ! Domain = 'VOL'; Use_Symmetry = F; Plane_Wave_Source = T

      write(*,421) '        Domain [zbmin,zbmax] :', zbmin, zbmax,         '  [', Units, ']'
      write(*,412) '         Discretization [Lz] :', Lz
      write(*,422) '                  Voxel [hz] :', hz   ,                '  [', Units, ']'

            ELSE                                 ! Domain = 'VOL'; Use_Symmetry = F; Plane_Wave_Source = F

      write(*,420) '  Domain [xbmin,ybmin,zbmin] :', xbmin, ybmin, zbmin,  '  [', Units, ']'
      write(*,420) '  Domain [xbmax,ybmax,zbmax] :', xbmax, ybmax, zbmax,  '  [', Units, ']'
      write(*,412) '   Discretization [Lx,Ly,Lz] :', Lx,    Ly,    Lz
      write(*,420) '            Voxel [hx,hy,hz] :', hx,    hy,    hz   ,  '  [', Units, ']'

            END IF                               ! End IF(Pane_Wave_Source)

         END IF                                  ! End IF(Use_Symmetry)

      ELSE IF(Domain .eq. 'SUR') THEN            ! Domain = 'SUR'

         IF(Use_Symmetry) THEN                   ! Domain = 'SUR'; Use_Symmetry = T

            IF(Plane_Wave_Source) THEN           ! Domain = 'SUR'; Use_Symmetry = T; Plane_Wave_Source = T
             
      write(*,*)   '**** For the chosen parameters surface is not discretized *************'

            ELSE                                 ! Domain = 'SUR'; Use_Symmetry = T; Plane_Wave_Source = F

      write(*,422) '  Max circle radius [rhomax] :', rhomax,               '  [', Units, ']'
      write(*,414) '    Number of circles [Lrho] :', Lrho 
      write(*,422) '     Radius increment [hrho] :', hrho,                 '  [', Units, ']'

            END IF                               ! End IF(Pane_Wave_Source)

         ELSE                                    ! Domain = 'SUR'; Use_Symmetry = F

            IF(Plane_Wave_Source) THEN           ! Domain = 'SUR'; Use_Symmetry = F; Plane_Wave_Source = T

      write(*,*)   '**** For the chosen parameters surface is not discretized *************'

            ELSE                                 ! Domain = 'SUR'; Use_Symmetry = F; Plane_Wave_Source = F

      write(*,421) '        Domain [xbmin,ybmin] :', xbmin, ybmin,         '  [', Units, ']'
      write(*,421) '        Domain [xbmax,ybmax] :', xbmax, ybmax,         '  [', Units, ']'
      write(*,413) '      Discretization [Lx,Ly] :', LX,    LY
      write(*,421) '               Pixel [hx,hy] :', hx,    hy,            '  [', Units, ']'

            END IF                               ! End IF(Pane_Wave_Source)

         END IF                                  ! End IF(Use_Symmetry)

      ELSE                                       ! DOMAIN =/= 'VOL' .OR. 'SUR' (Unsupported)

         write(*,*) 'REPORT_PARS Unexpected error: Incorrect Domain; exiting'
         return

      END IF                                     ! End Selection DOMAIN



      write(*,422) '           Source depth [z0] :', z0,                   '  [', Units, ']'

      IF(Collimated_Source) THEN

      write(*,420) '   Collimation [s0x,s0y,s0z] :', s0x,  s0y,  s0z

      END IF



      IF(Compute_I) THEN

         IF(Use_Symmetry .and. Plane_Wave_source) THEN

      write(*,413) '      Angular discr. [Nscth] :', Nscth

         ELSE 

      write(*,413) 'Angular discr. [Nscth,Nsphi] :', Nscth, Nsphi

         END IF

      END IF

      write(*,*)   '======================================================================='

      return
      end
