!DIR$ FIXEDFORMLINESIZE:132
      subroutine dd_cyl_I_3D(mode, errcode)
      use rte_blocks
      implicit none

      integer*4, intent(in)  :: mode
      integer*4, intent(out) :: errcode

      integer*8   irec, n, n_max

      real*4      fun
      real*4      rho, rho_of_irho
      real*4      scth, sphi, scth_of_iscth, sphi_of_isphi

      integer*4   k, l, irho, iscth, isphi 

      integer*4   ind
      character*4 answ

      real(nword), allocatable, dimension(:)     :: v
      real(nword), allocatable, dimension(:,:,:) :: I

      errcode = 0

      n_max = int8(lrho)*int8(Nsphi)*int8(Nscth)

      allocate(v(1:nline))
      allocate(I(1:Nscth,1:Nsphi,1:lrho))

      irec = 2
      read(80,rec=irec,err=1002) (v(l), l=1,nline)

      k = 0
      n = 0
      do 1, irho =1,lrho
      do 1, isphi=1,Nsphi
      do 1, iscth=1,Nscth
      k=k+1
      n=n+1
      I(iscth,isphi,irho) = v(k)
      if(k .eq. nline) then
         if(n .lt. n_max) then
            irec = irec+1 
            read(80,rec=irec,err=1002) (v(l), l=1,nline)
            k = 0
         else
            continue
         end if
      end if
 1    continue

      close(unit=80,err=1003)
      write(*,*) irec, 'records successfully read'

      deallocate(v)

 200  continue

 2    format(a4)
      write(*,*) 'Smoothen I(s) at the poles? [Y/N]'
      read(*,2) answ

      if((answ .eq. 'N') .or. (answ .eq. 'n')) then
         continue
      else if((answ .eq. 'Y') .or. (answ .eq. 'y')) then
         call smoothen_cyl_I_3D(I)
      else
         write(*,*) 'Incorrect answer; sould be Y or N; try again'
         goto 200 
      end if

 100  continue

      write(*,*) '***** I(r;s) = IT(C, phi, rho), where C=cos(theta). Make a choice: ****'
      write(*,*) '   Dump all available data into an ASCII file                       [1]'
      write(*,*) '   Display I(C=C0, phi     ; rho=rho0) as a function of phi         [2]'
      write(*,*) '   Display I(C,    phi=phi0; rho=rho0) as a function of C           [3]'
      write(*,*) '   Display I(C,    phi     ; rho=rho0) as a function of (C,phi)     [4]'
      write(*,*) '   Display I(C=C0, phi=phi0; rho     ) as a function of rho         [5]'
      write(*,*) '***********************************************************************'

      read(*,*) ind
      if((ind .lt. 1) .or. (ind .gt. 5)) then
         write(*,*) 'Response is outside of range or incorrect, ind=', ind
         goto 100
      end if
c
c------------- Getting integer idexes -------------------------
c
      if      (mode .eq. 1) then
         call gip_I_CIR(ind, iscth, isphi, irho)
      else if (mode .eq. 2) then
         call gii_I_CIR(ind, iscth, isphi, irho)
      else
         errcode = 1
         return
      end if
c
c------------- Writing data out --------------------------------------
c

      IF     (ind .eq. 1) THEN

         open(unit=70, file='I_C_phi_rho',status='unknown')

         do 11, irho=1,Lrho
         rho = rho_of_irho(irho)
         do 11, isphi=1,Nsphi
         sphi = sphi_of_isphi(isphi)
         do 11, iscth=1,Nscth
         scth = scth_of_iscth(iscth)
         fun = I(iscth,isphi,irho)
         write(70,*) scth, sphi, rho, fun
 11      continue

         write(*,*) '........ Output written to file "I_C_phi_rho" '
         write(*,*) '.................. Format: scth, sphi, rho, I '

      ELSE IF(ind .eq. 2) THEN

         open(unit=70, file='I_phi',status='unknown')

         do 12, isphi=1,Nsphi
         sphi = sphi_of_isphi(isphi)
         fun = I(iscth,isphi,irho)
         write(70,*) sphi, fun
 12      continue

         write(*,*) '....... Output written to file "I_phi" '
         write(*,*) '...................... Format: sphi, I '

      ELSE IF(ind .eq. 3) THEN

         open(unit=70, file='I_C',status='unknown')

         do 13, iscth=1,Nscth
         scth = scth_of_iscth(iscth)
         fun = I(iscth,isphi,irho)
         write(70,*) scth, fun
 13      continue

         write(*,*) '......... Output written to file "I_C" '
         write(*,*) '...................... Format: scth, I '

      ELSE IF(ind .eq. 4) THEN

         open(unit=70, file='I_C_phi',status='unknown')

         do 14, isphi=1,Nsphi
         sphi = sphi_of_isphi(isphi)
         do 14, iscth=1,Nscth
         scth = scth_of_iscth(iscth)
         fun = I(iscth,isphi,irho)
         write(70,*) scth, sphi, fun
 14      continue

         write(*,*) '..... Output written to file "I_C_phi" '
         write(*,*) '................ Format: scth, sphi, I '

      ELSE IF(ind .eq. 5) THEN

         open(unit=70, file='I_rho',status='unknown')

         do 15, irho=1,Lrho
         rho = rho_of_irho(irho)
         fun = I(iscth,isphi,irho)
         write(70,*) rho, fun
 15      continue

         write(*,*) '....... Output written to file "I_rho" '
         write(*,*) '......................  Format: rho, I '

      ELSE

         write(*,*) 'Incorrect index (should be 1<=ind<=5); please try again'
         goto 100

      END IF

      close(unit=70)


      write(*,*) 'Make another choice to display more data'
      write(*,*) '=============================================================================='
      write(*,*) '=============================================================================='

      goto 100

      return

 1002 continue
      write(*,*) 'dd_I_CYL: Error reading binary data'
      errcode = 1002
      return

 1003 continue
      write(*,*) 'dd_I_CYL: Error closing input file'
      errcode = 1003
      return

      end
