!DIR$ FIXEDFORMLINESIZE:132
      subroutine dd_rec_I_5D(mode, errcode)
      use rte_blocks
      implicit none

      integer*4, intent(in)  :: mode
      integer*4, intent(out) :: errcode

      integer*8   irec, n, n_max

      real*4      fun
      real*4      x, y, z, x_of_ix, y_of_iy, z_of_iz
      real*4      scth, sphi, scth_of_iscth, sphi_of_isphi

      integer*4   k, l, ix, iy, iz, iscth, isphi 

      integer*4   ind
      character*4 answ

      real(nword), allocatable, dimension(:)         :: v
      real(nword), allocatable, dimension(:,:,:,:,:) :: I

      errcode = 0

      n_max = int8(Nscth)*int8(Nsphi)*int8(lx)*int8(ly)*int8(lz)

      allocate(v(1:nline))
      allocate(I(1:Nscth,1:Nsphi,1:lx,1:ly,1:lz))

      irec = 2
      read(80,rec=irec,err=1002) (v(l), l=1,nline)

      k = 0
      n = 0
      do 1, iz=1,lz
      do 1, iy=1,ly
      do 1, ix=1,lx
      do 1, isphi=1,Nsphi
      do 1, iscth=1,Nscth
      k=k+1
      n=n+1
      I(iscth,isphi,ix,iy,iz) = v(k)
      if(k .eq. nline) then
         if(n .lt. n_max) then
            irec = irec+1 
            read(80,rec=irec,err=1002) (v(l), l=1,nline)
            k = 0
         else
            continue
         end if
      end if
 1    continue

      close(unit=80,err=1003)
      write(*,*) irec, 'records successfully read'

      deallocate(v)

 200  continue

 2    format(a4)
      write(*,*) 'Smoothen I(s) at the poles? [Y/N]'
      read(*,2) answ

      if((answ .eq. 'N') .or. (answ .eq. 'n')) then
         continue
      else if((answ .eq. 'Y') .or. (answ .eq. 'y')) then
         call smoothen_I_5D(I)
      else
         write(*,*) 'Incorrect answer; sould be Y or N; try again'
         goto 200 
      end if

 100  continue

      write(*,*) '***** I(r;s) = I(C, phi, x, y, z), where C=cos(theta). Make a choice: ********'
      write(*,*) '   Dump all available data into an ASCII file                              [1]'
      write(*,*) '   Display I(C=C0, phi     ; x=x0, y=y0, z=z0) as a function of phi        [2]'
      write(*,*) '   Display I(C,    phi=phi0; x=x0, y=y0, z=z0) as a function of C          [3]'
      write(*,*) '   Display I(C,    phi     ; x=x0, y=y0, z=z0) as a function of (C,phi)    [4]'
      write(*,*) '   Display I(C=C0, phi=phi0; x   , y   , z=z0) as a function of (x,y)      [5]'
      write(*,*) '   Display I(C=C0, phi=phi0; x   , y=y0, z   ) as a function of (x,z)      [6]'
      write(*,*) '   Display I(C=C0, phi=phi0; x=x0, y   , z   ) as a function of (y,z)      [7]'
      write(*,*) '   Display I(C=C0, phi=phi0; x   , y=y0, z=z0) as a function of x          [8]'
      write(*,*) '   Display I(C=C0, phi=phi0; x=x0, y   , z=z0) as a function of y          [9]'
      write(*,*) '   Display I(C=C0, phi=phi0; x=x0, y=y0, z   ) as a function of z         [10]'
      write(*,*) '******************************************************************************'

      read(*,*) ind
      if((ind .lt. 1) .or. (ind .gt. 10)) then
         write(*,*) 'Response is outside of range or incorrect, ind=', ind
         goto 100
      end if
c
c------------- Getting integer idexes -------------------------
c
      if      (mode .eq. 1) then
         call gip_I_3D(ind, iscth, isphi, ix, iy, iz)
      else if (mode .eq. 2) then
         call gii_I_3D(ind, iscth, isphi, ix, iy, iz)
      else
         errcode = 1
         return
      end if
c
c------------- Writing data out --------------------------------------
c

      IF     (ind .eq. 1) THEN

         open(unit=70, file='I_C_phi_x_y_z',status='unknown')

         do 11, iz=1,Lz
         z = z_of_iz(iz)
         do 11, iy=1,Ly
         y = y_of_iy(iy)
         do 11, ix=1,Lx
         x = x_of_ix(ix)
         do 11, isphi=1,Nsphi
         sphi = sphi_of_isphi(isphi)
         do 11, iscth=1,Nscth
         scth = scth_of_iscth(iscth)
         fun = I(iscth,isphi,ix,iy,iz)
         write(70,*) scth, sphi, x, y, z, fun
 11      continue

         write(*,*) '........ Output written to file "I_C_phi_x_y_z" '
         write(*,*) '................ Format: scth, sphi, x, y, z, I '

      ELSE IF(ind .eq. 2) THEN

         open(unit=70, file='I_phi',status='unknown')

         do 12, isphi=1,Nsphi
         sphi = sphi_of_isphi(isphi)
         fun = I(iscth,isphi,ix,iy,iz)
         write(70,*) sphi, fun
 12      continue

         write(*,*) '....... Output written to file "I_phi" '
         write(*,*) '...................... Format: sphi, I '

      ELSE IF(ind .eq. 3) THEN

         open(unit=70, file='I_C',status='unknown')

         do 13, iscth=1,Nscth
         scth = scth_of_iscth(iscth)
         fun = I(iscth,isphi,ix,iy,iz)
         write(70,*) scth, fun
 13      continue

         write(*,*) '......... Output written to file "I_C" '
         write(*,*) '...................... Format: scth, I '

      ELSE IF(ind .eq. 4) THEN

         open(unit=70, file='I_C_phi',status='unknown')

         do 14, isphi=1,Nsphi
         sphi = sphi_of_isphi(isphi)
         do 14, iscth=1,Nscth
         scth = scth_of_iscth(iscth)
         fun = I(iscth,isphi,ix,iy,iz)
         write(70,*) scth, sphi, fun
 14      continue

         write(*,*) '..... Output written to file "I_C_phi" '
         write(*,*) '................ Format: scth, sphi, I '

      ELSE IF(ind .eq. 5) THEN

         open(unit=70, file='I_x_y',status='unknown')

         do 15, iy=1,Ly
         y = y_of_iy(iy)
         do 15, ix=1,Lx
         x = x_of_ix(ix)
         fun = I(iscth,isphi,ix,iy,iz)
         write(70,*) x, y, fun
 15      continue

         write(*,*) '....... Output written to file "I_x_y" '
         write(*,*) '...................... Format: x, y, I '

      ELSE IF(ind .eq. 6) THEN

         open(unit=70, file='I_x_z',status='unknown')

         do 16, iz=1,Lz
         z = z_of_iz(iz)
         do 16, ix=1,Lx
         x = x_of_ix(ix)
         fun = I(iscth,isphi,ix,iy,iz)
         write(70,*) x, z, fun
 16   continue

         write(*,*) '....... Output written to file "I_x_z" '
         write(*,*) '...................... Format: x, z, I '

      ELSE IF(ind .eq. 7) THEN

         open(unit=70, file='I_x_z',status='unknown')

         do 17, iz=1,Lz
         z = z_of_iz(iz)
         do 17, iy=1,Ly
         y = y_of_iy(iy)
         fun = I(iscth,isphi,ix,iy,iz)
         write(70,*) y, z, fun
 17   continue

         write(*,*) '....... Output written to file "I_y_z" '
         write(*,*) '...................... Format: y, z, I '

      ELSE IF(ind .eq. 8) THEN

         open(unit=70, file='I_x',status='unknown')

         do 18, ix=1,Lx
         x = x_of_ix(ix)
         fun = I(iscth,isphi,ix,iy,iz)
         write(70,*) x, fun
 18      continue

         write(*,*) '......... Output written to file "I_x" '
         write(*,*) '......................... Format: x, I '

      ELSE IF(ind .eq. 9) THEN

         open(unit=70, file='I_y',status='unknown')

         do 19, iy=1,Ly
         y = y_of_iy(iy)
         fun = I(iscth,isphi,ix,iy,iz)
         write(70,*) y, fun
 19      continue

         write(*,*) '......... Output written to file "I_y" '
         write(*,*) '......................... Format: y, I '

      ELSE IF(ind .eq. 10) THEN

         open(unit=70, file='I_z',status='unknown')

         do 20, iz=1,Lz
         z = z_of_iz(iz)
         fun = I(iscth,isphi,ix,iy,iz)
         write(70,*) z, fun
 20      continue

         write(*,*) '......... Output written to file "I_z" '
         write(*,*) '......................... Format: z, I '

      ELSE

         write(*,*) 'Incorrect index (should be 1<=ind<=7); please try again'
         goto 100

      END IF

      close(unit=70)


      write(*,*) 'Make another choice to display more data'
      write(*,*) '=============================================================================='
      write(*,*) '=============================================================================='

      goto 100

      return

 1002 continue
      write(*,*) 'dd_I_3D: Error reading binary data'
      errcode = 1002
      return

 1003 continue
      write(*,*) 'dd_I_3D: Error closing input file'
      errcode = 1003
      return

      end
