      subroutine make_beta(g, beta, info)
      implicit none 
      real*4,    intent(in)  :: g
      real*4,    intent(out) :: beta
      integer*4, intent(out) :: info
 
      real*4 g1, g2, g3, b1, b2, b3
      real*4 beta_max, fun_exp
      parameter(beta_max=1000.0)

      info = 0

      b1 = -beta_max
      b2 = +beta_max
      g1 = fun_exp(b1)
      g2 = fun_exp(b2)
      
      if(g .le. g1) then
         write(*,*) 'MAKE_BETA error: g is too close to -1'
         info = 1
         return
      end if

      if(g .ge. g2) then
         write(*,*) 'MAKE_BETA error: g is too close to +1'
         info = 2
         return
      end if

 1    continue

      b3 = (b1 + b2) / 2.0
      g3 = fun_exp(b3)

      if(g .lt. g3) then
         b2 = b3
      else if(g .eq. g3) then
         beta = b3
         return
      else if(g .gt. g3) then
         b1 = b3
      else
         write(*,*) 'MAKE_BETA unexpected error A'
         info = 3
         return
      end if

      goto 1

      end
