      subroutine make_unums()
      use math_blocks
      use rte_blocks
      use header_types
      implicit none

      real*4, dimension(1:nr) :: arr, phi

c-------- To be used with SourceType='ISO' only
c
c-------- RNs for initial direction -------------------------
c
c........ UCT <-- Cos[Theta] : Uniform in [-1,1]
c........ UST <-- Sin[Theta] : Determined from UCT 
c........ UCP <-- Cos[Phi]
c........ USP <-- Sin[Phi]
c-----------------------------------------------------------
c

c-------- (STR5) Cosine of polar angle UCT: Uniform in [-1,1]
      vsl_errcode = vsrnguniform(meth5,str5,nr,uct,-ru,ru)
      call check_vsl_error(vsl_errcode)
      call check_cosines(nr,uct)
      call vssqr(nr,uct,arr)
      arr = ru - arr
      call vssqrt(nr,arr,ust)
c-------- (STR6) Azimuthal angle PHI: Uniform in [0,2*PI]      
      vsl_errcode = vsrnguniform(meth6,str6,nr,phi,rzero,pi2)
      call check_vsl_error(vsl_errcode)
      call vssin(nr,phi,usp)
      call vscos(nr,phi,ucp)

      return
      end
