      pure subroutine rotate_s(cth,sth,cph,sph,sx,sy,sz)
      implicit none

      real*4,    intent(in)    :: cth, sth, cph, sph
      real*4,    intent(inout) :: sx, sy, sz

      real*4 ux, uy, uz, a1, a2, a3, b1, b2, b3, cf
      real*4 sr, sn

  
      if(abs(sz) .le. 0.9) then

         sr =  sqrt(1.0 - sz*sz)
         cf =  sth / sr
         a1 =  sx*sz*cph - sy*sph
         a2 =  sy*sz*cph + sx*sph
         a3 =  sth*cph
         b1 =  sx*cth
         b2 =  sy*cth
         b3 =  sz*cth
         ux =  cf*a1 + b1
         uy =  cf*a2 + b2
         uz = -a3*sr + b3

      else if(abs(sy) .le. 0.9) then

         sr =  sqrt(1.0 - sy*sy)
         cf =  sth / sr
         a1 =  sz*sy*cph - sx*sph
         a2 =  sx*sy*cph + sz*sph
         a3 =  sth*cph
         b1 =  sz*cth
         b2 =  sx*cth
         b3 =  sy*cth
         uz =  cf*a1 + b1
         ux =  cf*a2 + b2
         uy = -a3*sr + b3

      else if(abs(sx) .le. 0.9) then

         sr =  sqrt(1.0 - sx*sx)
         cf =  sth / sr
         a1 =  sy*sx*cph - sz*sph
         a2 =  sz*sx*cph + sy*sph
         a3 =  sth*cph
         b1 =  sy*cth
         b2 =  sz*cth
         b3 =  sx*cth
         uy =  cf*a1 + b1
         uz =  cf*a2 + b2
         ux = -a3*sr + b3

c$$$      else
c$$$
c$$$         write(*,*) 'ROTATE_S unexpected error 1'
c$$$         pause
c$$$         return

      end if

      sn = sqrt(ux*ux + uy*uy + uz*uz)
      sx = ux/sn
      sy = uy/sn
      sz = uz/sn

      return
      end

         
