!DIR$ FIXEDFORMLINESIZE:132
      subroutine upd_plws_vol_rec(zw, sx, sy, sz)
      use math_blocks
      use rte_blocks
      use header_types
      implicit none  

      real*4, intent(in) :: zw, sx,sy,sz

      integer*4 iz, iz_of_z
      integer*4 iscth, iscth_of_scth, isphi, isphi_of_sphi

      real*4    arg, den, sphi

      if(zw  .lt. zbmin ) return
      if(zw  .ge. zbmax ) return

      iz   = iz_of_z(zw)

      if(compute_u) then 
         u1D(iz) = u1D(iz) + du
      end if

      if(compute_J) then 
         J2D(1,iz) = J2D(1,iz) + sx
         J2D(2,iz) = J2D(2,iz) + sy
         J2D(3,iz) = J2D(3,iz) + sz
      end if

      if(compute_I) then 
         iscth = iscth_of_scth(sz)

         if(abs(sz*sz-ru) .lt. small) then
            I3D(iscth,2:Nsphi-1,iz) =  I3D(iscth,2:Nsphi-1,iz) + sphifrac
            I3D(iscth,1        ,iz) =  I3D(iscth,1        ,iz) + sphihrac
            I3D(iscth,  Nsphi  ,iz) =  I3D(iscth,  Nsphi  ,iz) + sphihrac
          else
            den  = sqrt(sx*sx + sy*sy)
            arg  = sx/den
            if(arg .gt.  ru) arg =  ru
            if(arg .lt. -ru) arg = -ru
            sphi = acos(arg) / pi
            if(sy .lt. rzero) sphi = two - sphi
c$$$            if(sphi .lt. sphi_min) return
c$$$            if(sphi .gt. sphi_max) return
            isphi = isphi_of_sphi(sphi)
            I3D(iscth,isphi,iz) =  I3D(iscth,isphi,iz) + du
         end if
      end if

      return
      end
