!DIR$ FIXEDFORMLINESIZE:132
      subroutine upd_pnts_sur_rec_T(xw, yw, zw, dx, dy, dz, sx, sy, sz)
      use math_blocks
      use rte_blocks
      use header_types
      implicit none

      real*4, intent(in) :: xw, yw, zw
      real*4, intent(in) :: sx, sy, sz
      real*4, intent(in) :: dx, dy, dz

      real(nword) sxi, syi, szi, sfi, shi

      real*4    zet, xc, yc, arg, den, sphi
      integer*4 ix, iy, ix_of_x, iy_of_y, iscth, isphi, iscth_of_scth, isphi_of_sphi

      szi = du/sz
      sxi = sx*szi
      syi = sy*szi
      sfi = sphifrac*szi
      shi = sphihrac*szi

      zet = (zw - zsmax)/dz

      xc  = xw - zet*dx
      if(xc .lt. xbmin) return
      if(xc .ge. xbmax) return

      yc  = yw - zet*dy
      if(yc .lt. ybmin) return
      if(yc .ge. ybmax) return

      ix = ix_of_x(xc)
      iy = iy_of_y(yc)

      if(compute_u) then 
         uT2D(ix,iy) = uT2D(ix,iy) + szi
      end if

      if(compute_J) then 
         JT3D(1,ix,iy) = JT3D(1,ix,iy) + sxi  ! =sx*szi
         JT3D(2,ix,iy) = JT3D(2,ix,iy) + syi  ! =sy*szi
         JT3D(3,ix,iy) = JT3D(3,ix,iy) + du   ! =sz*szi
      end if

      if(compute_I) then 
c$$$         if(sz .lt. scth_min) return
c$$$         if(sz .gt. scth_max) return
         iscth = iscth_of_scth(sz)

         if(abs(sz*sz-ru) .lt. small) then
            IT4D(iscth,2:Nsphi-1,ix,iy) = IT4D(iscth,2:Nsphi-1,ix,iy) + sfi  ! =sphifrac*szi
            IT4D(iscth,1        ,ix,iy) = IT4D(iscth,1        ,ix,iy) + shi  ! =sphihrac*szi
            IT4D(iscth,  Nsphi  ,ix,iy) = IT4D(iscth,  Nsphi  ,ix,iy) + shi  ! =sphihrac*szi
         else
            den  = sqrt(sx*sx + sy*sy)
            arg  = sx/den
            if(arg .gt.  ru) arg =  ru
            if(arg .lt. -ru) arg = -ru
            sphi = acos(arg) / pi
            if(sy .lt. rzero) sphi = two - sphi
c$$$            if(sphi .lt. sphi_min) return
c$$$            if(sphi .gt. sphi_max) return
            isphi = isphi_of_sphi(sphi)
            IT4D(iscth,isphi,ix,iy) =  IT4D(iscth,isphi,ix,iy) + szi
         end if
      end if

      return
      end
